#! /bin/sh
#  author       : Achim Gaedke
#  filename     : ghmm/autogen.sh
#  created      : DATE: April 2001
#  $Id: autogen.sh 2327 2013-08-05 15:03:06Z ejb177 $

#move GNU m4 to head of PATH
sep_path=`echo $PATH|sed -n 's/:/ /gp'`
for f in $sep_path ; do
  test -f $f/m4 && echo `eval $f/m4 --version 2>/dev/null` |grep GNU >/dev/null && PATH=$f:$PATH
done

#creates ltmain.sh (Call first!!!)
if hash libtoolize 2>&-
then
    libtoolize --automake --force --copy
else
    glibtoolize --automake --force --copy
fi

#makes aclocal.m4 from acinclude.m4 and other files
aclocal

#scans configure.in and creates config.h.in
autoheader 

#creates Makefile.in from Makefile.am
automake --add-missing --force-missing

#creates configure from configure.in
autoconf


